Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/RenderingRuns/OgreFocusingMapRenderingRun.h
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/RenderingRuns/OgreFocusingMapRenderingRun.h	(revision 1125)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/RenderingRuns/OgreFocusingMapRenderingRun.h	(revision 2251)
@@ -13,5 +13,7 @@
 
 /**
-	@brief ColorCubeMapRenderingRun used in an OGRE environment.
+	@brief FocusingMapRenderingRun.
+
+	A run to help focusing light projections for shadow mapping.
 */
 class OgreFocusingMapRenderingRun : public OgreRenderingRun									
@@ -28,5 +30,5 @@
 								unsigned int focusingMapSize);
 	/**
-		@brief returns the name of the camera depth texture
+		@brief returns the name of the focusing texture
 	*/
 	String getFocusingTextureName(){return name;}
@@ -46,9 +48,9 @@
 	
 	/**
-		@brief the name of the depth texture that was created by this run
+		@brief the name of the focusing texture that was created by this run
 	*/
 	String name;
 	/**
-		@brief a pointer to the scene depth texture that was created by this run
+		@brief a pointer to the focusing texture that was created by this run
 	*/
 	Texture* focusingTexture;
Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/RenderingRuns/OgreCubeMapRenderingRun.h
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/RenderingRuns/OgreCubeMapRenderingRun.h	(revision 1886)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/RenderingRuns/OgreCubeMapRenderingRun.h	(revision 2251)
@@ -14,5 +14,5 @@
 
 /**
-	@brief ColorCubeMapRenderingRun used in an OGRE environment.
+	@brief CubeMapRenderingRun used in an OGRE environment.
 */
 class OgreCubeMapRenderingRun : public OgreRenderingRun,
@@ -34,4 +34,9 @@
 		@param angleTolerance		angle tolerance used in face skip		
 		@param updateAllFace		defines if all cubemap faces should be updated in a frame or only one face per frame
+		@param renderSelf			sets if the object should be rendered to the cube map
+		@param renderEnvironment	sets if the environment should be rendered to the cube map
+		@param selfMaterial			the material that should be set for the object while rendering the cubemap
+		@param environmentMaterial  the material that should be set for the environment while rendering the cubemap
+		@param getMinMax			sets if the minimum and maximum values of the cubemap should be computed		
 	*/	
 	OgreCubeMapRenderingRun(OgreSharedRuns* sharedRuns,
@@ -62,18 +67,30 @@
 
 	/**
-		@brief a pointer to the OgreSharedRuns this run belongs to
+		@brief A pointer to the OgreSharedRuns this run belongs to.
 	*/
 	OgreSharedRuns* sharedRuns;
 	/**
-		@brief the name of the cubemap texture that was created by this run
+		@brief The name of the cubemap texture that was created by this run.
 	*/
 	String name;
 	/**
-		@brief a pointer to the cubemap texture that was created by this run
+		@brief A pointer to the cubemap texture that was created by this run.
 	*/
 	Texture* cubemapTexture;
+	/**
+		@brief 
+	*/
 	String selfMaterial;
+	/**
+		@brief 
+	*/
 	bool useSelfMaterial;
+	/**
+		@brief 
+	*/
 	String environmentMaterial;
+	/**
+		@brief 
+	*/
 	bool useEnvMaterial;
 	RenderingRunType cubemapRunType;
@@ -82,5 +99,7 @@
 	Vector4 max;
 
-
+	/**
+		@brief 
+	*/
 	bool getMinMax;
 	
Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/RenderingRuns/OgreChildPSystemRenderingRun.h
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/RenderingRuns/OgreChildPSystemRenderingRun.h	(revision 2240)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/RenderingRuns/OgreChildPSystemRenderingRun.h	(revision 2251)
@@ -56,30 +56,50 @@
 		return false;
 	}
-
 	void setNode(SceneNode* n){psysNode = n;}
+	/**
+		@brief Returns the radius of the small particle system.
+	*/
 	Real getSmallSysRadius(){return sysRad;}
 
 protected:	
 	SceneNode* psysNode;
+	/**
+		@brief Sets if the impostor should be rendered with a perspective projection or orthogonal.
+	*/
 	bool perspectiveRendering;
+	/**
+		@brief Use the material that was defined in the particle script.
+	*/
 	bool useOwnMaterial;
+	/**
+		@brief Use this specific material while rendering the impostor.
+	*/
 	String materialName;
+	/**
+		@brief The name of the small particle system.
+	*/
 	String childParticleSystemName;
+	/**
+		@brief The name of the small particle system script.
+	*/
 	String particleScriptName;
+	/**
+		@brief Radius of the small particle system.
+	*/
 	Real sysRad;
 	/**
-		@brief the created photon hit map texture
+		@brief Camera used while rendering the impostor image.
 	*/
 	Camera* impostorCamera;
 	/**
-		@brief a pointer to the OgreSharedRuns this run belongs to
+		@brief A pointer to the OgreSharedRuns this run belongs to.
 	*/
 	OgreSharedRuns* sharedRuns;
 	/**
-		@brief the name of the photonmap texture that was created by this run
+		@brief The name of the imostor texture that was created by this run.
 	*/
 	String name;
 	/**
-		@brief a pointer to the photonmap texture that was created by this run
+		@brief A pointer to the impostor texture that was created by this run.
 	*/
 	Texture* impostorTexture;
Index: GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/RenderingRuns/OgreDepthShadowMapRenderingRun.h
===================================================================
--- GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/RenderingRuns/OgreDepthShadowMapRenderingRun.h	(revision 1688)
+++ GTP/trunk/Lib/Illum/IllumModule/OgreIllumModule/include/RenderingRuns/OgreDepthShadowMapRenderingRun.h	(revision 2251)
@@ -15,5 +15,5 @@
 
 /**
-	@brief ColorCubeMapRenderingRun used in an OGRE environment.
+	@brief DepthShadowMapRenderingRun used in an OGRE environment.
 */
 class OgreDepthShadowMapRenderingRun : public OgreRenderingRun,